import gtk
#this might be on Maemo
try:
	import hildon
	has_hildon = True
except:
	has_hildon = False
	
#what is the max number of dents we want to keep track of?
MAX_DENTS=50
class DentScroller(gtk.EventBox):
	def __init__(self):
		gtk.EventBox.__init__(self)
		#keep track of this dentscroller's ids
		self.ids = []
		#are we on Maemo?
		if has_hildon:
			try:
				#this will only work on maemo5; fuck Nokia's shitty documentation
				main_child = hildon.PannableArea()
			except:
				# a simple version check would be better, but the documentation is crap
				main_child = gtk.ScrolledWindow()
			hildon.hildon_helper_set_thumb_scrollbar(main_child, True)
		else:
			main_child = gtk.ScrolledWindow()
		self.add(main_child)	
		main_child.set_policy(gtk.POLICY_AUTOMATIC,gtk.POLICY_AUTOMATIC)
		self.dent_scroll_vbox=gtk.VBox(spacing=1)
		self.viewport = gtk.Viewport()
		self.viewport.add(self.dent_scroll_vbox)
		try:
			self.viewport.modify_bg(gtk.STATE_NORMAL,gtk.gdk.Color('#666') )
		except:
			#what the hell version of python-gtk is this?
			pass
		main_child.add(self.viewport)
		#pack an empty label to the end of this vbox
		self.dent_scroll_vbox.pack_end(gtk.Label("") )

		
	def add_dent(self,dent,is_conv=False):
		#is this id already in this scroller?
		dent_id = dent.id
		if not dent_id in self.ids:
			self.ids.append(dent_id)
			if is_conv:
				self.dent_scroll_vbox.pack_start(dent,False,False,0)
			else:
				self.dent_scroll_vbox.pack_end(dent,False,False,0)
			#hey! how many children does the self.dent_scroll_vbox have?
			children=self.dent_scroll_vbox.get_children()
			while len(children)>MAX_DENTS:
				self.dent_scroll_vbox.remove( children[-1] )
				d = children.pop()
				try:
					self.ids.remove(d.id)
				except:
					pass
			#it would be nice to see this dent
			dent.show_all()


	def clear(self):
		print "clearing..."
		children=self.dent_scroll_vbox.get_children()
		for child in children:
			self.dent_scroll_vbox.remove( child )
		#clear the ids
		self.ids = []
